using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

namespace Graphics
{
    [Activity(Label = "Record Video Activity")]
    public class recordvideo : Activity, ISurfaceHolderCallback
    {
        private const int RECORDVIDEO = 1;
        private const int HIGHVIDEOQUALITY = 1;
        private const int MMSVIDEOQUALITY = 0;
        Android.Media.MediaRecorder mediaRec;
        SurfaceView surface;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
            SetContentView(Resource.Layout.recordvideo);
            // Create your application here
            Button btn = FindViewById<Button>(Resource.Id.btnCloseRecordVideo);
            btn.Click += new EventHandler(btn_Click);
            Button btnVid = FindViewById<Button>(Resource.Id.btnTakeVideoNow);
            btnVid.Click += new EventHandler(btnVid_Click);

            mediaRec = new Android.Media.MediaRecorder();
            surface = (SurfaceView)FindViewById(Resource.Id.SurfacePlay);
            var holder = surface.Holder;
            holder.AddCallback(this);
            holder.SetType(Android.Views.SurfaceType.PushBuffers);
            holder.SetFixedSize(300, 200);
        }

        void btnVid_Click(object sender, EventArgs e)
        {
            recordVideo(null);
        }

        void btn_Click(object sender, EventArgs e)
        {
            this.Finish();
        }

        private void recordVideo(Uri outputpath)
        {
            //mediaRec.SetPreviewDisplay(surface);
            //mediaRec.SetAudioSource(Android.Media.AudioSource.Mic); 
            //mediaRec.SetVideoSource(Android.Media.VideoSource.Default); 
            //mediaRec.SetOutputFormat(Android.Media.OutputFormat.ThreeGpp); 
            //mediaRec.SetAudioEncoder(Android.Media.AudioEncoder.AmrNb); 
            //mediaRec.SetVideoEncoder(Android.Media.VideoEncoder.Mpeg4Sp); 
            //mediaRec.SetMaxDuration((int)MAX_TIME); 
            //mediaRec.SetOnInfoListener(m_BeMeSelf); 
            //mediaRec.SetVideoSize(320, 240); 
            //mediaRec.SetVideoFrameRate(15); 
            //mediaRec.SetOutputFile(m_path); 
            //mediaRec.Prepare(); 
            //mediaRec.Start();
            //Intent intent = new Intent(Android.Provider.MediaStore.IntentActionVideoCamera);
            //if (outputpath != null)
            //    intent.PutExtra(Android.Provider.MediaStore.ExtraOutput, outputpath.LocalPath);

            //intent.PutExtra(Android.Provider.MediaStore.ExtraVideoQuality, HIGHVIDEOQUALITY);
            //StartActivityForResult(intent, RECORDVIDEO);
        }

        protected override void OnActivityResult(int requestCode, Result resultCode, Intent data)
        {
            base.OnActivityResult(requestCode, resultCode, data);
            if (requestCode == RECORDVIDEO)
            {
                if ((data != null) && (data.Data != null))
                {
                    Android.Net.Uri recordedVideo = data.Data;
                    //mediaRec.SetDataSource(this, recordedVideo);
                    //mediaRec.PrepareAsync();
                }
            }
        }

        public void SurfaceCreated(ISurfaceHolder holder)
        {
            try
            {
                //mediaRec.SetPreviewDisplay(this);
                //mediaRec.SetDisplay(holder);
                //mediaRec.SetDataSource("http://www.aspnetpodcast.com/VideoFiles/VideoTestForMonoDroid.mp4");
                //mediaRec.Prepared += new EventHandler(mediaPlayer_Prepared);
                //
                //mediaPlayer.Prepare();
                //mediaPlayer.Start();
            }
            catch (System.Exception e)
            {
                Android.Util.Log.Debug("MEDIA_PLAYER", e.Message);
                Toast.MakeText(this, e.Message, ToastLength.Short).Show();
            }
        }

        void mediaPlayer_Prepared(object sender, EventArgs e)
        {
            mediaRec.Start();
        }

        public void SurfaceDestroyed(ISurfaceHolder holder)
        {
            mediaRec.Release();
        }

        public void SurfaceChanged(ISurfaceHolder holder, int i, int j, int k) { }

    }
}