﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace Graphics
{
    [Activity(Label = "Video Activity", MainLauncher = true)]
    public class Activity1 : Activity
    {
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            SetContentView(Resource.Layout.main);

            Button button = FindViewById<Button>(Resource.Id.myButton);
            button.Click += new EventHandler(button_Click);
            Button btnTP = FindViewById<Button>(Resource.Id.btnTakePicture);
            btnTP.Click += new EventHandler(btnTP_Click);
            Button btnRV = FindViewById<Button>(Resource.Id.btnRecordVid);
            btnRV.Click += new EventHandler(btnRV_Click);
        }

        void btnRV_Click(object sender, EventArgs e)
        {
            //Take pictures
            Intent i = new Intent();
            i.SetClass(this, typeof(recordvid));
            i.AddFlags(ActivityFlags.NewTask);
            StartActivity(i);
        }

        void btnTP_Click(object sender, EventArgs e)
        {
            //Take pictures
            Intent i = new Intent();
            i.SetClass(this, typeof(takepictures));
            i.AddFlags(ActivityFlags.NewTask);
            StartActivity(i);
        }

        
        void button_Click(object sender, EventArgs e)
        {
            Intent i = new Intent();
            i.SetClass(this, typeof(video));
            i.AddFlags(ActivityFlags.NewTask);
            StartActivity(i);
        }

        //void btnRV_Click(object sender, EventArgs e)
        //{
        //    Button btnRV = FindViewById<Button>(Resource.Id.btnRecordVideo);
        //    btnRV.Click += new EventHandler(btnRV_Click);
        //    //Record video
        //    Intent i = new Intent();
        //    i.SetClass(this, typeof(recordvideo));
        //    i.AddFlags(ActivityFlags.NewTask);
        //    StartActivity(i);

        //}

    }
}

