using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Media;

namespace Graphics
{
    [Activity(Label = "My Activity")]
    public class recordvid : Activity
    {
        int TakeVid = 1;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
            SetContentView(Resource.Layout.recordvid);
            Button btn = FindViewById<Button>(Resource.Id.btnRecordVid);
            btn.Click += new EventHandler(btn_Click);
            
        }
        void btn_Click(object sender, EventArgs e)
        {
            saveFullVid();
        }
        private void saveFullVid()
        {
            Intent intent = new Intent(Android.Provider.MediaStore.ActionVideoCapture);
            intent.PutExtra(Android.Provider.MediaStore.ExtraVideoQuality, 1);
            StartActivityForResult(intent, TakeVid);
        }
        protected override void OnActivityResult(int requestCode, Result resultCode, Intent data)
        {
            base.OnActivityResult(requestCode, resultCode, data);
            if (requestCode == TakeVid)
            {
                if (resultCode == Result.Ok)
                {
                    Android.Net.Uri recordedVideo = data.Data;
                    Toast.MakeText(this, String.Format("Video Saved To: {0}.", recordedVideo.Path), ToastLength.Long).Show();
                }
            }
        }
    }
}